﻿<%@ Assembly Name="Microsoft.SharePoint, Version=12.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c" %>
<%@ Page Language="C#" MasterPageFile="/_layouts/application.master" Inherits="Microsoft.SharePoint.WebControls.LayoutsPageBase" %>
<%@ Import Namespace="Microsoft.SharePoint" %>
<%@ Import Namespace="Microsoft.SharePoint.Administration" %>

<asp:Content runat="server" ContentPlaceHolderID="PlaceHolderPageTitle">
    <asp:Literal runat="server" Text="Show All Sites" />
</asp:Content>

<asp:Content runat="server" ContentPlaceHolderID="PlaceHolderPageTitleInTitleArea">
    <asp:Literal runat="server" Text="Show All Sites" />
</asp:Content>

<asp:Content runat="server" ContentPlaceHolderID="PlaceHolderLeftNavBar" />

<asp:Content runat="server" ContentPlaceHolderID="PlaceHolderMain">
    <asp:TreeView ID="tvSites" runat="server" />
</asp:Content>

<script runat="server">
    string login;
    protected void Page_Load(object sender, EventArgs e)
    {
        if (SPContext.Current.Web.CurrentUser == null)
            return;
        login = SPContext.Current.Web.CurrentUser.LoginName;

        SPSecurity.RunWithElevatedPrivileges(delegate()
        {
            SPWebService cs = SPWebService.ContentService;
            foreach (SPWebApplication wa in cs.WebApplications)
            {
                foreach (SPSite site in wa.Sites)
                {
                    using (SPWeb web = site.RootWeb)
                    {
                        AddWebToTreeIfAccess(web, tvSites.Nodes);
                    }
                    site.Dispose();
                }
            }
        });
        tvSites.CollapseAll();
    }

    private void AddWebToTreeIfAccess(SPWeb web, TreeNodeCollection treeNodeCollection)
    {
        if (web.WebTemplate == "OSRV"
         || web.WebTemplate == "SPSMSITEHOST"
         || web.WebTemplate == "SPSPERS")
            return;
        TreeNode tn = new TreeNode();
        foreach (SPWeb childweb in web.Webs)
        {
            AddWebToTreeIfAccess(childweb, tn.ChildNodes);
            childweb.Dispose();
        }
        bool userHasAccess = web.DoesUserHavePermissions(login, SPBasePermissions.ViewPages);
        if (userHasAccess
         || tn.ChildNodes.Count > 0)
        {
            if (userHasAccess)
            {
                tn.Text = web.Title;
                tn.NavigateUrl = web.Url;
            }
            else
            {
                tn.Text = "(" + web.Title + ")";
                tn.SelectAction = TreeNodeSelectAction.Expand;
            }
            treeNodeCollection.Add(tn);
        }
    }
</script>

